include machine.e
include get.e
tick_rate(100)
without trace
without warning




object  Junk
integer fn
fn=open("lspeedt.log","a")
sequence d
d=date()
printf(fn,"[%02d/%02d/%04d %02d:%02d:%02d]\n",
{d[2],d[3],d[1]+1900,d[4],d[5],d[6]})


include lanimal.e


sequence G
atom     LoopOverhead,t, DiaAccess

sequence  Kitty,KittyClone
sequence KittyHandle



Junk = TRUE

atom itorcount

clear_screen()

while 1 do
   itorcount=prompt_number("Enter the number of iterations (100-1000000): ",
   {100,1000000})
   if integer(itorcount) then exit end if
   puts(1,"An integer is expected here - try again\n")
end while 

puts(1,"\n")


Kitty = call_method(Cat,"new",{"Lucky",FALSE})  
KittyHandle=Kitty
LoopOverhead = time ()
for i = 1 to itorcount do end for
LoopOverhead = time () - LoopOverhead

constant fmt="%7d %-43s%9.6f\n"

procedure specprint(sequence text)
   printf(1,fmt,{itorcount,"iterations of Diamond Lite "&text&":",DiaAccess})
   printf(fn,fmt,{itorcount,"iterations of Diamond Lite "&text&":",DiaAccess}) 
end procedure



DiaAccess = time ()
  
Junk=call_method(Kitty,"Set_Test",{itorcount})  
  
DiaAccess = time () - DiaAccess - LoopOverhead


specprint("set_property()")


DiaAccess = time ()

Junk=call_method(Kitty,"Get_Test",{itorcount})

DiaAccess = time () - DiaAccess - LoopOverhead


specprint("get_property()")




DiaAccess = time ()
for i = 1 to itorcount do
   VOID = call_method (Kitty, "MakeNoise",{})
end for
DiaAccess = time () - DiaAccess - LoopOverhead

specprint("call_method()") 


DiaAccess = time ()      
for i = 1 to itorcount do
   Kitty=call_method(Cat,"new",{"Lucky",FALSE,FALSE,TRUE})
end for
DiaAccess = time () - DiaAccess - LoopOverhead


specprint("constructor") 

for i = 1 to itorcount do
   KittyHandle[2]=i
   VOID=call_method(KittyHandle,"delete",NONE)
end for
                                                                      

DiaAccess=time()
for i = 1 to itorcount do
   KittyClone=call_method(Kitty,"clone",NONE)
end for
DiaAccess=time()-DiaAccess-LoopOverhead
                                                                       
specprint("copy constructor")   
                           

t=time()
for i=1 to itorcount do
   KittyHandle[2]=i
end for
LoopOverhead+=time()-t


DiaAccess = time ()
for i = itorcount+1 to itorcount*2 do
   KittyHandle[2]=i
   VOID=call_method(KittyHandle,"delete",NONE)
end for
DiaAccess = time () - DiaAccess - LoopOverhead


specprint("destructor") 

close(fn)

puts(1, "\n\nDone.  Press any key to exit.") 
VOID=wait_key()


